import es, cfglib, services, playerlib, path

addonDir = path.path(es.getAddonPath('adminskins'))
downloads_path = addonDir.joinpath('downloads.cfg')

config = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + '/cfg/adminskins.cfg')
config.text("**************************")
config.text("        CT Models         ")
config.text("**************************")
adminskins_ct_urban   = config.cvar("adminskins_ct_urban",   'models/player/ics/admin_ct_fixed/urban.mdl', "CT Urban model")
adminskins_ct_gsg9   = config.cvar("adminskins_ct_gsg9",   'models/player/ics/admin_ct_fixed/urban.mdl', "CT gsg9 model")
adminskins_ct_sas   = config.cvar("adminskins_ct_sas",   'models/player/ics/admin_ct_fixed/urban.mdl', "CT Sas model")
adminskins_ct_gign   = config.cvar("adminskins_ct_gign",   'models/player/ics/admin_ct_fixed/urban.mdl', "CT Gign model")
config.text("**************************")
config.text("        T Models          ")
config.text("**************************")
adminskins_t_phoenix   = config.cvar("adminskins_t_phoenix",   'models/player/ics/admin_t_fixed/terror.mdl', "T Phoenix model")
adminskins_t_guerilla   = config.cvar("adminskins_t_guerilla",   'models/player/ics/admin_t_fixed/terror.mdl', "T Guerilla Model")
adminskins_t_leet   = config.cvar("adminskins_t_leet",   'models/player/ics/admin_t_fixed/terror.mdl', "T Leet Model")
adminskins_t_arctic   = config.cvar("adminskins_t_arctic",   'models/player/ics/admin_t_fixed/terror.mdl', "T Arctic Model")

config.write()

# ======================#
#         PUBLIC
# ======================#
info = es.AddonInfo()
info.name     = "Admin Skins"
info.version  = "2.5"
info.url      = "None"
info.basename = "sic_adminskins"
info.author   = "sicman_adrian"
es.ServerVar('sic_adminskins', info.version, info.name).makepublic()

def load():
    config.execute()
    setup_auth()

def es_map_start(ev):
    adddownloads()

def adddownloads():
    if downloads_path.isfile():
        a = open(downloads_path, 'r')
        b = a.readlines()
        for dlfile in a:
            es.stringtable('downloadables', dlfile.strip())
    else:
        downloads_path.touch()

def player_spawn(ev):
    userid = ev['userid']
    player = playerlib.getPlayer(userid)
    model = player.attributes['model']
    if ev['es_userteam'] == '3':
        if isAuthed(userid):
            if model == 'models/player/ct_urban.mdl':
                player.set('model', str(adminskins_ct_urban))
            elif model == 'models/player/ct_gsg9.mdl':
                  player.set('model', str(adminskins_ct_gsg9))
            elif model == 'models/player/ct_sas.mdl':
                  player.set('model', str(adminskins_ct_sas))
            elif model == 'models/player/ct_gign.mdl':
                  player.set('model', str(adminskins_ct_gign))
    elif ev['es_userteam'] == '2':
          es.msg('fired')
          if isAuthed(userid):
              es.msg('fuk me to')
              if model == 'models/player/t_guerilla.mdl':
                  player.set('model', str(adminskins_t_guerilla))
              elif model == 'models/player/t_phoenix.mdl':
                    player.set('model', str(adminskins_t_phoenix))
              elif model == 'models/player/t_leet.mdl':
                    player.set('model', str(adminskins_t_leet))
              elif model == 'models/player/t_arctic.mdl':
                    player.set('model', str(adminskins_t_arctic))

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('adminskins_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'adminskins_admin')
    else:
        isAuthed = lambda x: False